	$modxx51
	;pro prekladac ASM51
	;nastaveno pro krystal 12MHz
	bseg 	at 20h
Stav:	dbit	1
Pipat:	dbit	1
PrvniStisk:	dbit	1
KodzEEPROM:	dbit	1
NovyKod:	dbit	1

	dseg	at 30h
Zasobnik:	ds	40
PipT:	ds	1
PipN:	ds	1
PipD:	ds	1
PipL:	ds	1
	;definice vstupu/vystupu
SCL	equ	P3.0	;hodiny EEPROM
SDA	equ	P3.1	;data EEPROM
	;adresovaci vyvody A0 - A2 musi byt uzemneny
Pipak	equ	P3.5	;vystup pro piezo a LED
SaveKod	equ	P3.4	;vkladani noveho kodu (pri log.0)
Vystup	equ	P3.7	;vystup (aktivni - log.0)
ModeSelect	equ	P3.3	;volba modu
	;0 - kodem zapni, kodem vypni
	;1 - Kodem zapni, vypne samo po nastavene dobe
ZpozdeneOff	equ	10	;zpozdene vypnuti (od 4!!! do 255 vterin)
Vterina	equ	55	;timto se nastavuje delka 1 vteriny
AutoResetTime	equ	80	;doba za kterou se od posledniho stisku 
			;resetuje kod, 25=asi 1 vterina
	;zacatek kodu
	cseg
	;pocatecni nastaveni nekterych neuzitecnych promennych
Init:	mov	P1,#255
	mov	P3,#255
	mov	R5,#0
	mov	R6,#0
	mov	sp,#Zasobnik
	setb	Stav
	setb	Pipat
	clr	KodzEEPROM
	setb	PrvniStisk
	clr	NovyKod
	clr	rs0
	clr	rs1
	mov	a,#0
	mov	b,#1
	acall	Delay
	;zacatek programu
	;je pripojena EEPROM ?
	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	jc	EEPROMNeni
	;zjisti jesi v ni neco je
	mov	a,#00000000b
	acall	I2CPosilej
	acall	I2CStart
	mov	a,#10100001b
	acall	I2CPosilej	
	acall	I2CCti
	acall	I2CStop
	;vkladani noveho kodu?
	jb	SaveKod,EEPROMJe
	;do EEPROM se bude vkladat kod
PodelalTo:	acall	SmazUvodniZ
	setb	NovyKod
	jmp	ZapisZnakuu
	;z EEPROM se bude cist kod 
EEPROMJe:	cjne	a,#100,EEPROMNeni
EEPROMJeTest:	setb	KodzEEPROM
	;pamet neni pripojena
EEPROMNeni:	mov	a,#10
	mov	b,#20
	acall	Delay
	mov	R6,#0
	
	;porovnavani cisla kodu se zadanym cislem
	;reset
	;nejdriv zjisti jesi se zapisuje novy kod 
Reset:	jnb	NovyKod,Neres1
	;jo zapisuje
	mov	a,R6
	;jesi R6=0, tak to neres a skoc na Neres1
	jz	Neres1
	;R6 vetsi nez 0, takze to nekdo podelal - 3x dlouze pipni
	mov	a,#25
	mov	b,#50
	acall	Delay
	acall	Pip3xLong
	;a vrat se na zacatek zadavani noveho kodu
	setb	PrvniStisk
	mov	R6,#0
	jmp	PodelalTo
	;normalni reset
Neres1:	mov	R6,#0	;pozice znaku v kodu
	mov	R3,#0
	;smycka, kde se ctou tlacitka
Smycka:	acall	CtiButony
	inc	R3
	cjne	R3,#AutoResetTime,DalRad1
	jmp	Reset
DalRad1:	jz	Smycka
	mov	R3,#0
	acall	Pip1xShort
	;prekodovani klavesnice
	mov	dptr,#Dekoder
	movc	a,@a+dptr
	mov	R7,a	;v R7 stisknute cislo
	;nacteni R6-teho cisla
	;vyber jestli z PROM nebo EEPROM
	jb	KodzEEPROM,Pamet1
	;z PROM
	mov	dptr,#Kod
	mov	a,R6
	movc	a,@a+dptr
	jmp	DeASCII
	;z EEPROM
Pamet1:	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,R6
	inc	a
	acall	I2CPosilej
	acall	I2CStart
	mov	a,#10100001b
	acall	I2CPosilej
	acall	I2CCti
	acall	I2CStop
	;prevod z ASCII na norm. cislo
DeASCII:	clr	c
	subb	a,#48
	;srovnani
	xrl	a,R7
	inc	R6	;dalsi cislo v kodu
	jnz	Reset	;kdyz nesedi, tak reset
	;uz konec?
	;vyber jestli z PROM nebo EEPROM
	;z PROM
	jb	KodzEEPROM,Pamet2
	mov	a,R6
	movc	a,@a+dptr
	jmp	UzKonecKodu
	;z EEPROM
Pamet2:	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,R6
	inc	a
	acall	I2CPosilej
	acall	I2CStart
	mov	a,#10100001b
	acall	I2CPosilej
	acall	I2CCti
	acall	I2CStop
	;ted to zkus	
UzKonecKodu:	cjne	a,#255,DalsiProsim
	;uz to byl konec
	;prubni jestli slo o zapis noveho kodu do pameti
	jnb	NovyKod,Pamet3
	;zapis noveho kodu - zapis uvodniho znaku
	acall	ZapisUvodniZ
	;zpozdeni a 3x pip
	mov	a,#30
	mov	b,#25
	acall	Delay
	acall	Pip3xShort
	jmp	$	;zacykleni
	;sepni / vypni vystup
Pamet3:	mov	a,#30
	mov	b,#25
	acall	Delay
	;konec zpozdeni
	;mod 1 nebo 2 ?
	jb	ModeSelect,Mode1
	;mod 2
	;zapnuti
	acall	Pip3xShort
	clr	Vystup
	clr	Stav
	;vypnuti
	mov	a,#ZpozdeneOff
	clr	c
	subb	a,#4
	mov	R0,a
	;tu cekej ZpozdeneOff - 4 vterin a blikej LEDkou
Mode2Loop1:	mov	a,#Vterina
	mov	b,#35
	acall	Delay
	clr	Pipat
	acall	Pip1xShort
	setb	Pipat
	djnz	R0,Mode2Loop1
	;tu cekej 3 vteriny a jeste pipej
	mov	R0,#3
Mode2Loop2:	mov	a,#Vterina
	mov	b,#35
	acall	Delay
	acall	Pip1xShort	;1x pipni
	djnz	R0,Mode2Loop2	
	;tu uz pipni dlouze a deaktivuj vystup
	mov	a,#Vterina
	mov	b,#30
	acall	Delay
	acall	Pip1xLong	;1x dlouze pipni
	setb	Vystup
	setb	Stav
	jmp	Reset
	;mod 1
Mode1:	jnb	Stav,LongPip
	acall	Pip3xShort
	jmp	ShortPip
LongPip:	acall	Pip1xLong
ShortPip:	cpl	Stav
	mov	c,Stav
	mov	Vystup,c
	jmp	Reset
	;bec!
DalsiProsim:	jmp	Smycka	
	;zpozdovaci smycka
Delay:	setb	rs1
	mov	R0,b
Delay2:	mov	R1,a
Delay1:	mov	R2,#255
	djnz	R2,$
	djnz	R1,Delay1
	djnz	R0,Delay2
	mov	b,#1
	clr	rs1
	ret
	;cteni maticovych tlacitek do a
	;(detekuji se pouze zmeny oproti minulemu cteni, jinak a = 0)	
CtiButony:	mov	R2,#0
	mov	R1,#0
	mov	R7,#11111110b
	mov	P1,R7
	;2x osetreni zakmitu
PrubniJestli:	mov	R0,P1
	mov	a,#5
	acall	Delay
	mov	a,P1
	mov	R4,a
	xrl	a,R0
	jnz	PrubniJestli
	mov	a,#5
	acall	Delay
	mov	R0,P1
	mov	a,R4
	xrl	a,R0
	jnz	PrubniJestli
	mov	a,R4
	;testik, jestli je v tomhle radku neco stiskly
	cpl	a
	anl	a,#01110000b
	jz	DalsiRadek
	cjne	R1,#0,Chyba	;nekdo zmackl 2 tlacitka zaroven
	rl	a
	;vyhodnoceni v kterym sloupci je to stiskly
KerejSloupec:	inc	R1
	rlc	a
	jnc	KerejSloupec
	jnz	Chyba	;nejakej vul zmackl 2 tlacitka zaroven
	;cti dalsi radek
DalsiRadek:	mov	a,R1
	jnz	UzNasel
	mov	a,R2
	add	a,#3
	mov	R2,a
UzNasel:	mov	a,R7
	rl	a
	jnb	acc.4,Hotovo
	mov	R7,a
	mov	P1,a
	jmp	PrubniJestli
	;talcitko zjisteny a stiskly jen jedno
Hotovo:	mov	a,R1
	jz	Chyba
	clr	c
	add	a,R2
	mov	R4,a
	xrl	a,R5
	jz	Stejne
	mov	a,R4
	mov	R5,a
	ret
	;nekdo stiskl 2 a vic zaroven nebo nic
Chyba:	mov	a,#0
	mov	R5,a
	ret
	;predchozi cteni stejny jako ted
Stejne:	mov	a,#0
	ret
	
	;1x kratky pipnuti
Pip1xShort:	mov	PipN,#1	;pocet pipnuti
	mov	PipL,#15	;delka pipnuti
	mov	PipD,#10	;mezera mezi pipnutimi
	mov	PipT,#75	;1/frekvence tonu
	acall	Pipani
	ret
	;3x kratky pipnuti
Pip3xShort:	mov	PipN,#3	;pocet pipnuti
	mov	PipL,#15	;delka pipnuti
	mov	PipD,#10	;mezera mezi pipnutimi
	mov	PipT,#75	;1/frekvence tonu	
	acall	Pipani
	ret
	;1x dlouhy pipnuti
Pip1xLong:	mov	PipN,#1	;pocet pipnuti
	mov	PipL,#150	;delka pipnuti
	mov	PipD,#1	;mezera mezi pipnutimi
	mov	PipT,#75	;1/frekvence tonu	
	acall	Pipani
	ret
	;3x dlouhy pipnuti
Pip3xLong:	mov	PipN,#3	;pocet pipnuti
	mov	PipL,#150	;delka pipnuti
	mov	PipD,#20	;mezera mezi pipnutimi
	mov	PipT,#75	;1/frekvence tonu	
	acall	Pipani
	ret
	;valstni generator pipani
	;PipT - 1/frekvence
	;PipN - pocet pipnuti
	;PipD - prodleva mezi pipanim
	;PipL - delka pipnuti
Pipani:	setb	rs0
	;pocet pipnuti
	mov	R3,PipN
PipNRun1:	;ton + delka pipnuti
	mov	R1,PipL
PipLRun1:	mov	R7,#10
PipLRun2:	mov	R0,PipT
	djnz	R0,$
	clr	Pipak
	mov	R0,PipT
	djnz	R0,$
	jnb	Pipat,Nepipej
	setb	Pipak
Nepipej:	djnz	R7,PipLRun2
	djnz	R1,PipLRun1
	;delka mezery
	setb	Pipak
	cjne	R3,#1,PipDRun
	jmp	PipKonec
PipDRun:	mov	R2,PipD
PipDRun1: 	mov	R6,#15
PipDRun2:	mov	R7,#0
	djnz	R7,$
	djnz	R6,PipDRun2
	djnz	R2,PipDRun1
	;patri k poctu pipnuti
PipKonec:	djnz	R3,PipNRun1
	;konec	
	clr	rs0
	ret
	;tu je skoro vse se sbernici I2C
	;zpozdeni pro I2C
DelS:	nop
	nop
	ret
	;I2C start
I2CStart:	setb	SDA
	setb	SCL
	acall	DelS
	clr	SDA
	acall	DelS
	clr	SCL
	acall	DelS
	ret
	;I2C stop
I2CStop:	setb	SCL
	acall	DelS
	setb	SDA
	acall	DelS
	ret
	;cteni bytu z I2C do a
I2CCti:	mov	R0,#8
	setb	SDA
	acall	DelS
Cti1:	setb	SCL
	acall	DelS
	mov	c,SDA
	clr	SCL
	acall	DelS
	rlc	a
	djnz	R0,Cti1
	;ACK
	setb	SDA
	acall	DelS
	setb	SCL
	acall	DelS
	clr	SCL
	acall	DelS
	clr	SDA
	acall	DelS
	ret
	;posilani bytu z a na sbernici I2C
I2CPosilej:	mov	R0,#8
Posilej1:	rlc	a
	mov	SDA,c
	acall	DelS
	setb	SCL
	acall	DelS
	clr	SCL
	acall	DelS
	djnz	R0,Posilej1
	;do c nacti ACK
	setb	SDA
	acall	DelS
	setb	SCL
	acall	DelS
	mov	c,SDA
	clr	SCL
	acall	DelS
	clr	SDA
	ret
	;ukladani cisel do pameti
	;cteni klavesnice
ZapisZnakuu:	acall	CtiButony
	jb	PrvniStisk,JesteNeSave
	inc	R3
	cjne	R3,#AutoResetTime,JesteNeSave
	jmp	SaveNovyKod
JesteNeSave:	jz	ZapisZnakuu
	;plna pamet?
	cjne	R6,#254,NePlnaEEP
	jmp	SaveNovyKod
	;prekodovat a prevest na ASCII
NePlnaEEP:	mov	dptr,#Dekoder
	movc	a,@a+dptr
	add	a,#48
	push	acc
	mov	R3,#0
	acall	Pip1xShort
	clr	PrvniStisk
	inc	R6
	;ulozit stiskle tlacitko do pameti
	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,R6
	acall	I2CPosilej
	pop	acc
	acall	I2CPosilej
	acall	I2CStop
	jmp	ZapisZnakuu
	;zapis zaverecneho znaku (#255) do pameti
SaveNovyKod:	inc	R6
	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,R6
	acall	I2CPosilej
	mov	a,#255
	acall	I2CPosilej
	acall	I2CStop
	mov	a,#10
	mov	b,#20
	acall	Delay
	acall	Pip3xShort
	jmp	EEPROMJeTest
	;zapis uvodniho znaku (#100)
ZapisUvodniZ:	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,#00000000b
	acall	I2CPosilej
	mov	a,#100
	acall	I2CPosilej
	acall	I2CStop
	ret
	;"smaz" (zapis #255) uvodni znak
SmazUvodniZ:	acall	I2CStart
	mov	a,#10100000b
	acall	I2CPosilej
	mov	a,#00000000b
	acall	I2CPosilej
	mov	a,#255
	acall	I2CPosilej
	acall	I2CStop
	ret
			
	;tu se pise vlastni kod (max. 255 cifer :-), pouzitelne jsou cisla 0-9, # a *
Kod:	db	'555823'
	; 255 zakoncuje kod - nemenit !!
	db	255
	;sloupce se ctou v poradi P1.6, P1.5 a P1.4
	;radky se ctou v poradi P1.0, P1.1, P1.2 a P1.3
	;tady uvadim priklad jak to nastavit a zapojit
	;
	;         P1.4  P1.5  P1.6	
	;           |     |     |          
	;   P1.3 -- 7 --- 8 --- 9
	;           |     |     |
	;   P1.2 -- 4 --- 5 --- 6
	;           |     |     |
	;   P1.1 -- 1 --- 2 --- 3
	;           |     |     |
	;   P1.0 -- * --- 0 --- #
	;
Dekoder:	db	250	;tohle nemenit
	;takze jsem si zvolil nejake pripojeni P1.0 az P1.6 ke klavesnici (nakres nahore)
	;tak jak jsem to zapojil to tedy znamena, 
	;ze se cte po radcich zprava doleva a od spodu nahoru
	;takze uz jen pisu cisla tak je ctu porade, cili:
	db	243,0,250,3,2,1,6,5,4,9,8,7
	;# = 243, * = 250 a tyto 2 znaky lze v kodu pouzivat take
	;ps.: takhle jsem to zapojil jen proto, aby se mi dobre kreslilo schema :-)
	;ale muze to byt libovolne prehazene
		
	end	